from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes
from Products.SimpleFolderWithWorkflow.config import PROJECTNAME, GLOBALS
from Products.CMFCore.utils import getToolByName


def addToFactoryTool(self, out):
     print >> out, 'portal_factory modifications started.'
     
     ftool = getToolByName(self, 'portal_factory')
     
     if ftool:
          portal_factory_types = ftool.getFactoryTypes().keys()
               
     for portalType in [ typeDict['portal_type'] for typeDict in listTypes(PROJECTNAME) ]:
          if portalType not in portal_factory_types:
               portal_factory_types.append(portalType)
               ftool.manage_setPortalFactoryTypes(listOfTypeIds=portal_factory_types)
               print >> out, '    %s now uses portal_factory' % portalType
                    
     print >> out, 'portal_factory modifications done.'
     

def install(self):
    """Install content types, enable the portal factory"""

    out = StringIO()
    print >> out, "Installing %s" % PROJECTNAME

    # install the types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    print >> out, "Installed types"     
    addToFactoryTool(self, out)     
    

    # do the generic setup stuff
    tool=getToolByName(self, "portal_setup")
    profile = "profile-Products.%s:default" % PROJECTNAME

    try:
         tool.runAllImportStepsFromProfile(profile, purge_old=False)
    except AttributeError:   # before plone 3
         tool.setImportContext(profile)
         tool.runAllImportSteps(purge_old=False)

    print >> out, 'Ran all import steps.'
    return out.getvalue()

